#This code will look just at sampling individuals at random

setwd("C:/Users/shoban.DESKTOP-DLPV5IJ/Dropbox/Projects/Fant_USFS_white_ash/")
setwd("C:/Users/shoban/Dropbox/Projects/Fant_USFS_white_ash/")
setwd("/home/user/Dropbox/Projects/Fant_USFS_white_ash/")
library(adegenet); library(parallel); library(doParallel); source("Fa_sample_funcs.R")
colMax <- function(data) sapply(data, max, na.rm = TRUE)
sample.pop<-function(genind_obj,vect_pop_ID,vect_samp_sizes){
        for (p in 1:length(vect_pop_ID))
        alleles[p,]<-colSums(genind_obj[[vect_pop_ID[p]]]@tab[sample(1:nrow(genind_obj[[vect_pop_ID[p]]]@tab), vect_samp_sizes[p]),],na.rm=T)
        alleles
}       

	#Note that "lumped" has a dummy population at the end because the code requires more than one population
	Fa_genind<-read.genepop("whiteash_genepop_lumped.gen",ncode=3); Fa_genind_sep<-seppop(Fa_genind)
	Fa_genpop<-genind2genpop(Fa_genind)
	list_allele_cat<-c("global","glob_v_com","glob_com","glob_lowfr","glob_rare","reg_rare","loc_com_d1","loc_com_d2","loc_rare")
	num_scen<-1; num_reps<-100; scen<-1;	type_samp<-c("random")
	
	n_pops<-length(levels(Fa_genind@pop));	n_total_indivs<- length(Fa_genind@tab[,1])-1
	n_ind_p_pop<-table(Fa_genind@pop)
	allele_freqs<-colSums(Fa_genpop@tab)/(n_total_indivs*2)	
	summ_results<-array(dim=c(n_total_indivs,11,num_scen,num_reps))

	allele_cat<-get.allele.cat(Fa_genpop, list(1), 1, n_ind_p_pop)	
	glob<-allele_cat[[1]];			glob_v_com<-allele_cat[[2]];	glob_com<-allele_cat[[3]];		glob_lowfr<-allele_cat[[4]];		
	glob_rare<-allele_cat[[5]];		reg_com_int<-allele_cat[[6]];	loc_com_d1<-allele_cat[[7]]; 	loc_com_d2<-allele_cat[[8]];	
	loc_rare<-allele_cat[[9]]
	

cl <- makeCluster(4); registerDoParallel(cl) 
list_results <- foreach (nrep = 1:num_reps, .packages="adegenet")	%dopar% {

	for (samp in 2:n_total_indivs){
		alleles<-matrix(nrow=1,ncol=length(allele_freqs)); alleles<-sample.pop(Fa_genind_sep,1,samp)
		summ_results[samp,1:2,scen,nrep]<-c(samp, 1)
		for (l in 1:length(allele_cat)) summ_results[samp,l+2,scen,nrep]<-sum(colSums(alleles,na.rm=T)[allele_cat[[l]]]>0)
	}
	for(l in 1:length(allele_cat)) summ_results[length(summ_results[,1,1,1]),l+2,scen,nrep]<-length(allele_cat[[l]])
	summ_results[,,1,nrep]
}
for (nrep in 1:num_reps) summ_results[,,1,nrep] <- list_results[[nrep]]

stopCluster(cl)

for (n in 1:num_reps) summ_results[,3:11,1,n]<-t(t(summ_results[,3:11,1,n])/summ_results[length(summ_results[,1,1,1]),3:11,1,n])	
all_mean<-apply(summ_results[,,1,1:num_reps],c(1,2),mean)


pdf(file="accum_curve.pdf")
for (foc_all in c(3:11)){
	boxplot(summ_results[,foc_all,1,]~all_mean[,1], xlab="number of trees total", ylab="proportion of genetic variation preserved", main=list_allele_cat[foc_all-2])
	plot(all_mean[,foc_all]~all_mean[,1],pch="", xlab="number of trees total", ylab="proportion of genetic variation preserved", main=list_allele_cat[foc_all-2])
	lines(all_mean[,foc_all]~all_mean[,1],lty=1,lwd=2)
}
dev.off()